package week09

trait CList[+T] {
  def foreach[U](f: T=>U): Unit
  def ::[U >: T](head: U): Nemures[U] = Nemures(head,this)
}
case object Ures extends CList[Nothing]{
  override def foreach[U](f: Nothing => U): Unit = ()
}
case class Nemures[T](head: T, tail: CList[T]) extends CList[T]{
  override def foreach[U](f: T => U): Unit = {
    f(head)
    tail foreach f
  }
}

object ListMain extends App {
  def printNamedList(list: CList[week09.NamedObject]) =
    list.foreach( x => println(x.name))

  val morcos = Cat("Morcos")
  val nyuszi = Cat("Nyuszi")

  val what = if( 3 < 4 ) morcos


  val list: CList[Cat] = morcos :: nyuszi :: Ures
  val list2: CList[NamedObject] = Dog("Freya") :: list
  printNamedList(list2)
}