package week12

import org.scalatest.concurrent.{Signaler, TimeLimitedTests}
import org.scalatest.flatspec.AnyFlatSpec
import org.scalatest.time.{Millis, Span}

class GyakorlatTest  extends AnyFlatSpec with TimeLimitedTests {
  val timeLimit: Span = Span(1000, Millis)
  override val defaultTestSignaler: Signaler = new Signaler {
    override def apply(testThread: Thread): Unit = {
      println("Ez a teszt túl sokáig fut.")
      testThread.stop()
    } //unsafe, never használd.
  }

  "Műkincs konstruktor" should "throw an exception if size is not positive" in {
    assertThrows[IllegalArgumentException]{
      val mukincs = Mukincs("mk001", "műkincs 1", -1, 1)
    }
  }

}