package week09

trait Eloleny
trait Allat extends Eloleny
case class Macska(name: String) extends Allat
case class Kutya(name: String) extends Allat

trait MyPartialFunction[-In, +Out]{
  def apply(in: In): Out
  def isDefined(in: In): Boolean
}

object FunctionMain extends App {

  val macskaFuggveny:PartialFunction[Allat,String]  = {
    case _ : Macska => "Macska"
  }
  val allatList: List[Allat] = List( Macska("Nyuszi"), Macska("Morcos"), Kutya("Freya"), Macska("Omega"))
  //legyűjtjük a macskaneveket
  val macskaNevFuggveny: PartialFunction[Allat, Macska] = {
    case x:Macska => x
  }
  val macskaNevList: List[Allat] = allatList.collect( {
    case x:Macska if x.name.length==6 => x
    case x:Kutya => x
  } )
  println(macskaNevList)
}